--//

local function drawLaps(v, player)
	if not ((gametyperules & GTR_RACE) and (circuitmap)) then return end
	if not kFuncs.isValid(player) then return end
	
	local player_laps = player.laps + 1
	local total_laps = CV_FindVar("numlaps").value
	
	local x, y = 9, 10
	local flags = V_SNAPTOTOP | V_SNAPTORIGHT | V_HUDTRANS | V_PERPLAYER

	v.draw(x, y, v.cachePatch("K_SMOLSTK"), flags, nil)
	v.draw(x + 3, y - 1, v.cachePatch("KF_LAPS"), flags, nil)
	
	if (player.exiting) then	
		v.draw(x + 22, y, v.cachePatch("KF_FIN"), flags, nil)
	else
		kFuncs.drawNum(v, x + 17, y, player_laps, {flags = flags, font = "K_TNYNUM", pad = 2, space = 6})
		v.draw(x + 31, y, v.cachePatch("KF_SLASH"), flags, nil)
		kFuncs.drawNum(v, x + 37, y, total_laps, {flags = flags, font = "K_TNYNUM", pad = 2, space = 6})
	end
end
hud.add(drawLaps, "game")

--//

local function drawCountdown(v, player)
	if not (gametyperules & GTR_RACE) then return end
	if not ((leveltime > TICRATE) and (leveltime <= (5 * TICRATE))) then return end
	
	local timer = ((4 * TICRATE) - leveltime) + TICRATE
	local flash = ((leveltime / 4) & 1) and 2 or 1
	
	local count = timer / TICRATE
	
	local x, y = 160, 100
	local flags = V_PERPLAYER
	
	local final_patch = nil
	local patches = {
		[0] = {"KF_COUNTGO_A", "KF_COUNTGO_B"},
		
		{"KF_COUNT1_A", "KF_COUNT1_B"},
		{"KF_COUNT2_A", "KF_COUNT2_B"},
		{"KF_COUNT3_A", "KF_COUNT3_B"},
	}
	
	final_patch = v.cachePatch(patches[max(0, min(count, 3))][flash])
	if (final_patch) then
		v.draw(x - (final_patch.width / 2), y - (final_patch.height / 2), final_patch, flags, nil)
	end
end
hud.add(drawCountdown, "game")

--//

local function drawFinish(v, player)

	if not (gametyperules & GTR_RACE) then return end
	if (kFuncs.finish_tics >= (2 * TICRATE)) then return end

	local flash = ((leveltime / 4) & 1) and 2 or 1
	local patches = v.cachePatch(({"KF_FIN_A", "KF_FIN_B"})[flash])
	
	local x, y = (v.width() / v.dupx()), 100
	local flags = V_PERPLAYER
	
	local xval = patches.width
	local yval = patches.height / 2
	
	if (player.exiting) then
		kFuncs.finish_tics = min($ + 1, 2 * TICRATE)
	end
	
	if (kFuncs.finish_ticker == 1) then
		S_StartSound(nil, sfx_s3k6a, player)
	end
	
	x = ((TICRATE - kFuncs.finish_tics) * ((xval > $) and xval or $)) / TICRATE
	v.draw(x + 160 - (xval / 2), y - yval, patches, flags, nil)
end
hud.add(drawFinish, "game")

--//