--//

kFuncs.title_tics = 0
kFuncs.finish_tics = 0

--//

function kFuncs.isValid(mo)
	return (mo and mo.valid)
end

--//

function kFuncs.getTimer(timer)
	local tics, downwards, timelimitintics
	
	local cv_hidetime = CV_FindVar("hidetime")
	local countdowntimer = mapheaderinfo[gamemap].countdown * TICRATE
		
	if (timelimit > 0) then
		timelimitintics = timelimit * (60*TICRATE)
	end
	
	if ((gametyperules & GTR_STARTCOUNTDOWN) and (cv_hidetime and cv_hidetime.value) and (timer <= (cv_hidetime.value * TICRATE))) then
		tics = ((cv_hidetime.value * TICRATE) - timer) + (TICRATE - 1)
		downwards = true

	else
		if ((gametyperules & GTR_TIMELIMIT) and timelimit) then
			if (timelimitintics > timer) then
				tics = (timelimitintics - timer) + (TICRATE - 1)
			else
				tics = 0
			end
			
			downwards = true

		elseif (gametyperules & GTR_STARTCOUNTDOWN) then
			tics = timer - (hidetime * TICRATE)	

		elseif (mapheaderinfo[gamemap].countdown) then
			tics = countdowntimer - timer
			downwards = true

		else
			tics = timer
			downwards = false
		end
	end
	
	downwards = $ and (tics < (30 * TICRATE)) and ((leveltime % 10) < 5)
	return tics, downwards
	
end

--//

function kFuncs.drawNum(v, x, y, number, extra)
	local font	   = (extra) and extra.font 	or "STTNUM"
	local pad	   = (extra) and extra.pad 		or 0
	local space	   = (extra) and extra.space 	or 0
	
	local flags    = (extra) and extra.flags 	or 0
	local colormap = (extra) and extra.colormap or nil
	
	number = tostring($)
	
	if (pad and tonumber(pad)) then
		number = string.format("%0" .. pad .. "d", $)
	end
	
	local newx = x
	
	for i = 1, string.len(number) do
		local bit = string.sub(number, i, i)
		local patch = v.cachePatch(font .. bit)
				
		v.draw(newx, y, patch, flags, colormap)
		
		if kFuncs.isValid(patch) then
			newx = $ + (space or patch.width)
		end
	end
end

--//

local function resetVars()
	kFuncs.title_tics = 0
	kFuncs.finish_tics = 0
end

addHook("MapChange", resetVars)
addHook("GameQuit", resetVars)

--//